class Person {
  def activities = []
  
  def methodMissing(String name, args) {
    println "**** intercepting call to $name"
    if(name.startsWith('play')) {
      def activity = name - 'play'
      if(activities.contains(activity)) {
        def impl = {Object[] theArgs ->
          print "I love to play $activity"
          if(theArgs) 
            println " with ${theArgs.join(', ')}"
          else 
            println ""
        } 
        Person thisPerson = this
        thisPerson.metaClass."$name" = impl
        impl(args)
      } else {
        println "Sorry I don't play $activity"
      }
    } else {
      throw new MissingMethodException(name, Person, args)
    }
  }
}

def sam = new Person()
sam.activities = ['Tennis', 'Football']

println "# of methods: ${sam.metaClass.methods.size()}"

sam.playTennis()
println "# of methods: ${sam.metaClass.methods.size()}"

sam.playTennis()

sam.playFootball('Mark')
println "# of methods: ${sam.metaClass.methods.size()}"

sam.playFootball('Jim')